<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.6                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2015                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_auto_subscribe extends cmsPlugin {

    public $config = array (
        'is_board' => 1,
        'is_blog_post' => 1,
        'is_article' => 1,
        'is_photos' => 1,
        'is_catalog' => 1
    );

    public function __construct(){

        $this->info = array(
            'plugin'      => 'p_auto_subscribe',
            'title'       => 'Автоподписка',
            'description' => 'Автоматически подписывает автора при добавлении поста в блоге, статьи, фото, записи в каталоге или объявления',
            'author'      => '<a href="http://www.instantvideo.ru/" target="_blank">InstantMedia team</a>',
            'version'     => '1.3',
            'published'   => 1
        );

        $this->events = array(
            'ADD_BOARD_DONE',
            'ADD_POST_DONE',
            'ADD_ARTICLE_DONE',
            'ADD_CATALOG_DONE',
            'ADD_PHOTO_DONE'
        );

        parent::__construct();

        $this->inUser = cmsUser::getInstance();

    }

    public function execute($event, $item){

        global $_LANG;
        $success = false;

        switch ($event){
            case 'ADD_BOARD_DONE':   $success = $this->subscribeBoard($item); break;
            case 'ADD_POST_DONE':    $success = $this->subscribeBlogPost($item); break;
            case 'ADD_ARTICLE_DONE': $success = $this->subscribeArticle($item); break;
            case 'ADD_CATALOG_DONE': $success = $this->subscribeCatalog($item); break;
            case 'ADD_PHOTO_DONE': $success = $this->subscribePhoto($item); break;
        }

        if($success){
            cmsCore::addSessionMessage($_LANG['PS_START'].$_LANG['PS_'.strtoupper($event)], 'info');
        }

        return $item;

    }

// ==================================================================== //

    private function subscribeBoard($item) {
        if(!$this->config['is_board']) { return false; }
        if ($this->inUser->id){
            $user_id = isset($item['user_id']) ? $item['user_id'] : $this->inUser->id;
            if($user_id){
                return $this->subscribe($user_id, 'boarditem', $item['id']);
            }
        }
        return false;
    }

    private function subscribeBlogPost($item) {
        if(!$this->config['is_blog_post']) { return false; }
        if ($this->inUser->id && $item['user_id']){
            return $this->subscribe($item['user_id'], 'blog', $item['id']);
        }
        return false;
    }

    private function subscribeArticle($item) {
        if(!$this->config['is_article']) { return false; }
        if ($this->inUser->id && $item['user_id']){
            return $this->subscribe($item['user_id'], 'article', $item['id']);
        }
        return false;
    }

    private function subscribeCatalog($item) {
        if(!$this->config['is_catalog']) { return false; }
        if ($this->inUser->id && $item['user_id']){
            return $this->subscribe($item['user_id'], 'catalog', $item['id']);
        }
        return false;
    }

    private function subscribePhoto($item) {
        if(!$this->config['is_photos']) { return false; }
        if ($this->inUser->id && $item['user_id']){
            return $this->subscribe($item['user_id'], 'photo', $item['id']);
        }
        return false;
    }

    private function subscribe($user_id, $target, $target_id) {
        if (!$this->inDB->rows_count('cms_subscribe', "user_id = '$user_id' AND target = '$target' AND target_id = '$target_id'")){
            $sql = "INSERT INTO cms_subscribe (user_id, target, target_id, pubdate)
                    VALUES ('{$user_id}', '{$target}', '{$target_id}', NOW())";
            $this->inDB->query($sql);
            return true;
        }
        return false;
    }

}
